Index: trunk/src/VBox/Runtime/common/path/RTPathAbsDup.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathAbsDup.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathAbsDup.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathAbsEx.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathAbsEx.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathAbsEx.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2019-2020 Oracle Corporation
+ * Copyright (C) 2019-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathAbsExDup.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathAbsExDup.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathAbsExDup.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathAppend.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathAppend.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathAppend.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2009-2020 Oracle Corporation
+ * Copyright (C) 2009-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathAppendEx.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathAppendEx.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathAppendEx.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2009-2020 Oracle Corporation
+ * Copyright (C) 2009-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathCalcRelative.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathCalcRelative.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathCalcRelative.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013-2020 Oracle Corporation
+ * Copyright (C) 2013-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathChangeToDosSlashes.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathChangeToDosSlashes.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathChangeToDosSlashes.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathChangeToUnixSlashes.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathChangeToUnixSlashes.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathChangeToUnixSlashes.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathCopyComponents.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathCopyComponents.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathCopyComponents.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathCountComponents.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathCountComponents.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathCountComponents.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathEnsureTrailingSeparator.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathEnsureTrailingSeparator.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathEnsureTrailingSeparator.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathExt.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathExt.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathExt.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathFilename.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathFilename.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathFilename.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathFilenameUtf16.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathFilenameUtf16.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathFilenameUtf16.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathFindCommon.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathFindCommon.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathFindCommon.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2020 Oracle Corporation
+ * Copyright (C) 2020-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathFindCommon.cpp.h
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathFindCommon.cpp.h	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathFindCommon.cpp.h	(revision 93115)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2020 Oracle Corporation
+ * Copyright (C) 2020-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathGlob.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathGlob.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathGlob.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathHasExt.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathHasExt.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathHasExt.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathHasPath.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathHasPath.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathHasPath.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathJoin.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathJoin.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathJoin.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathJoinA.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathJoinA.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathJoinA.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathJoinEx.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathJoinEx.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathJoinEx.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathParentLength.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathParentLength.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathParentLength.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2019-2020 Oracle Corporation
+ * Copyright (C) 2019-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathParentLength.cpp.h
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathParentLength.cpp.h	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathParentLength.cpp.h	(revision 93115)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2019-2020 Oracle Corporation
+ * Copyright (C) 2019-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathParse.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathParse.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathParse.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathParse.cpp.h
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathParse.cpp.h	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathParse.cpp.h	(revision 93115)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathParseSimple.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathParseSimple.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathParseSimple.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathParsedReassemble.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathParsedReassemble.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathParsedReassemble.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013-2020 Oracle Corporation
+ * Copyright (C) 2013-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathPurgeFilename.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathPurgeFilename.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathPurgeFilename.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathRealDup.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathRealDup.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathRealDup.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathRmCmd.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathRmCmd.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathRmCmd.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013-2020 Oracle Corporation
+ * Copyright (C) 2013-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathSkipRootSpec.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathSkipRootSpec.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathSkipRootSpec.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathSplit.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathSplit.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathSplit.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013-2020 Oracle Corporation
+ * Copyright (C) 2013-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathSplitA.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathSplitA.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathSplitA.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013-2020 Oracle Corporation
+ * Copyright (C) 2013-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathSplitReassemble.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathSplitReassemble.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathSplitReassemble.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013-2020 Oracle Corporation
+ * Copyright (C) 2013-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathStartsWithRoot.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathStartsWithRoot.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathStartsWithRoot.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathStripExt.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathStripExt.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathStripExt.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathStripFilename.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathStripFilename.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathStripFilename.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathStripTrailingSlash.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathStripTrailingSlash.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathStripTrailingSlash.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/RTPathTraverseList.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathTraverseList.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/RTPathTraverseList.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2009-2020 Oracle Corporation
+ * Copyright (C) 2009-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/comparepaths.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/comparepaths.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/comparepaths.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/rtPathRootSpecLen.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/rtPathRootSpecLen.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/rtPathRootSpecLen.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2010-2020 Oracle Corporation
+ * Copyright (C) 2010-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/rtPathVolumeSpecLen.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/rtPathVolumeSpecLen.cpp	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/rtPathVolumeSpecLen.cpp	(revision 93115)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/rtpath-expand-template.cpp.h
===================================================================
--- trunk/src/VBox/Runtime/common/path/rtpath-expand-template.cpp.h	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/rtpath-expand-template.cpp.h	(revision 93115)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2020 Oracle Corporation
+ * Copyright (C) 2006-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Runtime/common/path/rtpath-root-length-template.cpp.h
===================================================================
--- trunk/src/VBox/Runtime/common/path/rtpath-root-length-template.cpp.h	(revision 85385)
+++ trunk/src/VBox/Runtime/common/path/rtpath-root-length-template.cpp.h	(revision 93115)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2019-2020 Oracle Corporation
+ * Copyright (C) 2019-2022 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as